package dk.vitality.lib.foundation.ref;

import org.jetbrains.annotations.NotNull;

public class FatPair<A, B>
{
	@NotNull public final A a;
	@NotNull public final B b;

	public FatPair(@NotNull A a, @NotNull B b)
	{
		this.a = a;
		this.b = b;
	}

	@Override
	public boolean equals(Object o)
	{
		if (this == o)
			return true;
		if (o == null || getClass() != o.getClass())
			return false;
		FatPair x = (FatPair)o;
		return a.equals(x.a) && b.equals(x.b);

	}

	@Override
	public int hashCode()
	{
		return 31 * a.hashCode() + b.hashCode();
	}
}
