/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>

@interface InstallerApp : NSObject <NSApplicationDelegate, NSURLSessionDelegate, NSURLSessionTaskDelegate, NSURLSessionDataDelegate, NSURLSessionDownloadDelegate> {
}

- (instancetype)init;
- (void)dealloc;

- (IBAction)quit:(id)sender;
- (IBAction)orderFrontStandardAboutPanel:(id)sender;

- (IBAction)handleButtonSkipThisVersion:(id)sender;
- (IBAction)handleButtonRemindMeLater:(id)sender;
- (IBAction)handleButtonInstallUpdate:(id)sender;

- (IBAction)handleProgressOkButton:(id)sender;
- (IBAction)handleProgressAllVersionsButton:(id)sender;

- (BOOL)validateMenuItem:(NSMenuItem *)menuItem;


- (void)URLSession:(NSURLSession *)session downloadTask:(NSURLSessionDownloadTask *)downloadTask
didFinishDownloadingToURL:(NSURL *)location;


//  NSApplicationDelegate
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification;
- (BOOL)application:(NSApplication *)theApplication openFile:(NSString *)filename;
- (BOOL)applicationOpenUntitledFile:(NSApplication *)theApplication;

- (void)handleEvent:(NSAppleEventDescriptor *)event withReplyEvent:(NSAppleEventDescriptor *)replyEvent;

@end
