/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>

@class FilterRuleEdit;

@interface FilterRuleTextField : NSTextField<NSTextDelegate> {
	FilterRuleEdit* _ruleController;
	BOOL _isRegexp;
	BOOL _wasEnabled;
}

- (void)setRuleController:(FilterRuleEdit*)ctrl;
- (void)setIsRegExp:(BOOL)isRegexp;

@property (readonly) BOOL becomeFirstResponder;
@property (readonly) BOOL resignFirstResponder;

- (BOOL)textView:(NSTextView *)aTextView shouldChangeTextInRange:(NSRange)affectedCharRange replacementString:(NSString *)replacementString;
@end

//==============================================================================

@interface FilterRuleFieldEditor : NSTextView
{
}

- (void)paste:(id)sender;

@end
