/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>

@class Prefs;
@class AlertHelper;
@class ServerCommunication;
@class FilterTabController;
@class HistoryTableView;

@interface HistoryController : NSObject<NSTableViewDataSource,NSTableViewDelegate,NSSplitViewDelegate> {
}

- (instancetype)initWithFilterTabController:(FilterTabController*)filterTabController
				withContainerView:(NSView*)containerView
					   withBundle:(NSBundle*)bundle;
- (void)dealloc;

- (void)notifyBecameVisible;
- (void)notifyBecameHidden;
- (void)notifyUpdatedAuthorizationState;

- (void)startTimerWithImmediateExecute:(BOOL)immediate;
- (void)stopTimer;

- (IBAction)enableAction:(id)sender;
- (IBAction)editAction:(id)sender;

@end

@interface HistoryTableView : NSTableView
{
}

- (IBAction)copy:(id)sender;

@end

