/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.admin.filter;

import org.glimmerblocker.proxy.admin.AbstractAdminXmlHandler;
import org.glimmerblocker.proxy.proxyRequest.ProxyRequestHandler;
import org.jetbrains.annotations.NotNull;
import dk.vitality.lib.foundation.misc.RandomUtils;
import dk.vitality.lib.foundation.xml.xpath.XmlArgs;

public class AdminFilterSubUpdate extends AbstractAdminXmlHandler
{
	public AdminFilterSubUpdate(@NotNull ProxyRequestHandler req) throws Exception
	{
		super(req);
	}

	protected void processAdminXml() throws Exception
	{
		long st0 = System.currentTimeMillis();
		int filterId = urlParams.reqInt("filter-id");
		XmlArgs containerXA = globals.filterSubscriptions.updateSubscription(filterId, true, Long.MAX_VALUE);
		if (containerXA != null)
			rootE.appendChild(doc.importNode(containerXA.getContextElement(), true));
		else
			ln("Can't return filter data from update.");
		//if (xa != null)
		//	ln(new DocumentPrinter(xa.getDocument()).printToString());
		if (urlParams.has("skip-delay"))
			return;
		// make the spinner anim take at least ~1 second so it always visible even if the server
		// is extremly fast.  Easier to do here than in ObjC.
		// Make the time a bit random so updating several subscriptions gives the impression of "life".
		long dur = System.currentTimeMillis() - st0;
		long minTime = 1000 + RandomUtils.randomizer.nextInt(500);
		long wait = minTime - dur;
		if (wait > 0)
			Thread.sleep(wait);
	}
}
