/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.globals.log;

import org.jetbrains.annotations.Nullable;

/**
 * Generic Logger interface. Many classes implement this interface to make logging more convenient, and
 * adding methods should therefore be done with care.
 */
public interface Logger
{
	/**
	 * Log a string.
	 *
	 * @param s Newline is automatically added, so it corresponds to PrintWriter.println(s)
	 */
	void ln(@Nullable String s);
}
