/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.http.client.stream;

import java.net.URL;
import org.glimmerblocker.proxy.http.data.Headers;
import org.jetbrains.annotations.NotNull;

public class RequestData
{
	@NotNull public final String method;
	@NotNull public final URL url;
	@NotNull public final Headers headers;
	@NotNull public final RequestBody body;

	public RequestData(@NotNull String method,
	                   @NotNull URL url,
	                   @NotNull Headers headers,
	                   @NotNull RequestBody body)
	{
		this.method = method;
		this.url = url;
		this.headers = headers;
		this.body = body;
	}
}
