/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.http.client.stream;

import java.io.IOException;
import java.io.InputStream;
import java.net.Socket;
import java.net.SocketException;
import org.jetbrains.annotations.NotNull;

public class SocketTimeoutableInputStream extends TimeoutableInputStream
{
	@NotNull protected final InputStream src;
	@NotNull protected final Socket skt;

	public SocketTimeoutableInputStream(@NotNull InputStream src, @NotNull Socket skt)
	{
		this.src = src;
		this.skt = skt;
	}

	public int read() throws IOException
	{
		return src.read();
	}

	public int read(@NotNull byte[] b, int off, int len) throws IOException
	{
		return src.read(b, off, len);
	}

	public void setReadTimeout(int timeout) throws SocketException
	{
		skt.setSoTimeout(timeout);
	}
}
