/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.rule;

import org.jetbrains.annotations.NotNull;
import dk.vitality.lib.foundation.xml.xpath.XmlArgs;

public class BlockerRule extends AbstractRule
{
	public BlockerRule(boolean isPreview,
	                   int filterId,
	                   @NotNull String filterName,
	                   @NotNull XmlArgs xa) throws Exception
	{
		super(isPreview, filterId, filterName, xa, RuleType.Blocker);
	}

	/**
	 * Do NOT rely on the contents of this string for anything. It is only for debugging.
	 */
	public String toString()
	{
		StringBuilder sb = new StringBuilder(100);
		sb.append("Block{");
		toStringMatching(sb);
		sb.append("}");
		appendFilterName(sb);
		return sb.toString();
	}
}
